/*
 * this is a plugin test usable for protocol incapsulation
 * and cover channel test of innova. using icmp unreachable
 * code, this is simply a test, using this for real hiding
 * pourpose should be wrost than an mail from hotmail.com :)
 *
 * vecna@s0ftpj.org - Fri Oct 10 04:36:34 CEST 2003
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <netinet/ip.h>
#include <netinet/ip_icmp.h>

#include "innova.h"
#include "userdefs.h"

#define IPT_MATCH_EXTENSION	"-p icmp --icmp-type destination-unreachable"

static char *plug_desc="covert channel over icmp packets";

static char ipt_mss_clamping_cmd[MAXCOMMANDLEN];

char *get_io_desc(int *pv)
{
	*pv =PLUGIN_FORMAT;
	return plug_desc;
}

/*
 * in this case, I'm using incapsulation (ip + icmp) this cause that the
 * packet big than my MTU, must be fragmented.
 *
 * I'm impulsive, and I've coded the function mtu_change, this was a problem
 * because also the sendto of innova is under MTU restriction :)
 *
 * for this reason, I've realized that the uniqe way is run another iptables
 * command with MSS clamping rule, for limit only the session discriminated
 * and not all interface session, and for evade this rules sending packets 
 * that's don't match (or from innova pid :)
 */
int mangle_init(struct innova_struct *is)
{
	short delta;

	/* 
	 * cover channel use struct ip and struct icmp as addictional
	 * header, this cause that the MTU of interface must be 
	 * decremented, for cause decementation on MSS too and doesn't
	 * require to handle fragmentation on covering plugin or with
	 * IP fragmentation
	 *
	 * the max MSS must be not MTU - (iphdr + ip opt + tcp hdr + tcpopt), 
	 * but MTU - (iphdr + ip opt + tcp hdr + tcp opt + ip hdr + ip opt + icmp) ...
	 */
	delta =(sizeof(struct iphdr) + MAX_IPOPTLEN) *2 + sizeof(struct icmphdr) + sizeof(struct tcphdr) + 12;

	snprintf(ipt_mss_clamping_cmd, MAXCOMMANDLEN,
        "%s -A OUTPUT -t mangle -d %s/%s -p tcp --tcp-flags SYN,RST SYN -j TCPMSS --set-mss %d",
			IPTABLES_PATH,
			is->o->remote->h_name,
			is->o->network != NULL ? is->o->network->n_name : "255.255.255.255",
			(is->min_MSS -delta)
		);

	checked_execution(ipt_mss_clamping_cmd);

	/*
	 * return < 0 is error, and innova is break,
	 * return 0 is for repeat mangle_init,
	 * return > 0 is for init success, innova continue happy
	 */
	return 1;
}

/* 
 * error who should be fixed, is fixed in this function and is returned
 * a value > or == to 0, with a return value < 0 innova end him
 * running. is error is know and should be handled, here is try to fix
 * (after is recalled mangle_init from handle_packets in innova.c main
 */
int mangle_cleanup(struct innova_struct *is, int error)
{
	int ret =0x00;

	switch(errno)
	{
		case EPERM:
			innova_p(ERROR_ERRNO, "%s should be dropped for filter precedent rule, fix it", 
				plug_desc);
			ret =-1;
			break;
		case ENOBUFS:
			innova_p(ERROR_ERRNO, "%s detect %s interface full, restarting plugin",
				plug_desc, is->o->interface);
			return (0x00);
		case 0:
			innova_p(ERROR, "%s cleaning up for user signal request", plug_desc);
			ret =-1;
			break;
		default:
			innova_p(ERROR_ERRNO, "%s is unable to handle error", plug_desc);
			ret =-1;
	}

	/* 
	 * if we are waiting to return -1, and code is reach here, we must delete
	 * iptables MSS rules!
	 */
	IPTCMD_DELETE_RULES(ipt_mss_clamping_cmd);

	return ret;
}

/*
 * incapsulate packets in icmp data and build icmp header
 */
int local_mangle(struct innova_struct *is, struct innova_packet *pkt)
{
#define ICMP_TYPE	3
#define ICMP_MAX_CODE	16

	static int icmp_code;
	static unsigned char swap_pkt[BUFSIZE];
	static int swap_pkt_len;
	struct icmphdr *icmp =NULL;

	/* save original packet size */
	swap_pkt_len =pkt->length;
	/* copy original packet */
	memcpy(swap_pkt, pkt->ip, pkt->length);

	/* 
	 * build new packet over the old, with icmp header point
	 * over the old transport layer protocol and unset old 
	 * pkt params
	 */
	switch(pkt->ip->protocol)
	{
		case IPPROTO_TCP:
			icmp =(struct icmphdr *)pkt->tcp;

			pkt->tcp_opt =NULL;
			pkt->tcp_opt_len =0x00;

			break;
		case IPPROTO_UDP:
			icmp =(struct icmphdr *)pkt->udp;

			pkt->udp =NULL;

			break;
		case IPPROTO_ICMP:
			icmp =pkt->icmp;
			break;
		default:
			innova_p(FATAL, "protocol not supported in [%s]", plug_desc);
			break;
	}

	memset(icmp, 0x00, sizeof(struct icmphdr));
	icmp->type =ICMP_DEST_UNREACH;
	icmp->code =icmp_code;

	/* 
	 * for use all icmp unreachable code, this is a test :) 
	 * NR_ICMP_UNREACH is 15 with 16 type 
	 */
	if(++icmp_code > NR_ICMP_UNREACH)
		icmp_code =0x00;

	/* fix pointer for new transport protocol */
	pkt->icmp =icmp;

	/* fix new payload pointer, before sendto is fixed by innova */
	pkt->data =swap_pkt;

	/* set exactly payload length, original iphdr + icmp + old length */
	pkt->data_len =swap_pkt_len + (pkt->ip->ihl *4) + sizeof(struct icmphdr);

	/* fix ip protocol */
	pkt->ip->protocol =IPPROTO_ICMP;
	pkt->ip->tot_len =htons(pkt->data_len);
	pkt->ip->check =0x00;

	return 0x00;
}

/*
 * decapsulate original packets from icmp payload
 */
int remote_mangle(struct innova_struct *is, struct innova_packet *pkt)
{
	/* for be sure, should be passed a bad packet ... */
	if(pkt->icmp ==NULL || pkt->icmp->type !=ICMP_DEST_UNREACH)
		return 0x00;
	/*
	 * the api use for indexing a raw packet on struct innova_packet should
	 * work nice here, simple I discard the old ip and icmp header used for cover
	 */
	fill_pkt_pointer(pkt, pkt->data);

	return 0x00;
}

int foo_mangle_f(unsigned char hook, struct innova_struct *is, struct innova_packet *pkt, void *x)
{
	/*
	 * possibile hook:
	 *
	 * INIT_HOOK, CLEANUP_HOOK, OPT_PARSE_HOOK, LOCAL_M_HOOK,
	 * REMOTE_M_HOOK, UNKNOW_M_HOOK, TIMEEXC_HOOK
	 */
	return 0x00;
}

int io_timeexceed(struct innova_struct *is, int *timeout)
{
	return 0x00;
}

/*
 * there are not command line options here, but this should be nice for
 * change innova tipical setting with setting useful for plugin
 * (also init the foo variable on the struct and the foo function pointer
 * on innova_struct or innova_options.
 */
int option_parser(struct innova_struct *is, struct innova_options *iopt)
{

	/*
	 * firewall rules must be different, the packets drop because locally 
	 * generated is discriminated with command line, the packets remotly
	 * discriminated must became with source host of remote host (and is
	 * already ok), protocol icmp and type unreachable.
	 */
	iopt->remote_match_ext =IPT_MATCH_EXTENSION;
	iopt->rem_serv =NULL;
	iopt->retocol =protocol_resolve("icmp");
	
	return 0x00;
}
